cabal-version: 1.12

-- This file has been generated from package.yaml by hpack version 0.34.7.
--
-- see: https://github.com/sol/hpack

name:           ligo-squirrel
version:        0.0.0
build-type:     Simple

library
  exposed-modules:
      AST
      AST.Capabilities
      AST.Capabilities.CodeAction.ExtractTypeAlias
      AST.Capabilities.Completion
      AST.Capabilities.DocumentLink
      AST.Capabilities.DocumentSymbol
      AST.Capabilities.Find
      AST.Capabilities.Folding
      AST.Capabilities.Format
      AST.Capabilities.Hover
      AST.Capabilities.Rename
      AST.Capabilities.SelectionRange
      AST.Capabilities.SignatureHelp
      AST.CodeAction
      AST.Includes
      AST.Parser
      AST.Parser.Camligo
      AST.Parser.Jsligo
      AST.Pretty
      AST.Scope
      AST.Scope.Common
      AST.Scope.Fallback
      AST.Scope.FromCompiler
      AST.Scope.ScopedDecl
      AST.Scope.ScopedDecl.Parser
      AST.Scope.Standard
      AST.Skeleton
      Cli
      Cli.Impl
      Cli.Json
      Cli.Types
      Config
      Diagnostic
      Extension
      ListZipper
      Log
      Parser
      ParseTree
      Product
      Progress
      Range
      Util
      Util.Graph
  other-modules:
      Paths_ligo_squirrel
  hs-source-dirs:
      src/
  default-extensions:
      AllowAmbiguousTypes
      ApplicativeDo
      BangPatterns
      BlockArguments
      ConstraintKinds
      DataKinds
      DeriveAnyClass
      DeriveFoldable
      DeriveFunctor
      DeriveGeneric
      DeriveTraversable
      DerivingStrategies
      DerivingVia
      DuplicateRecordFields
      FlexibleContexts
      FlexibleInstances
      FunctionalDependencies
      GADTs
      GeneralisedNewtypeDeriving
      ImportQualifiedPost
      LambdaCase
      MagicHash
      MultiParamTypeClasses
      MultiWayIf
      NamedFieldPuns
      OverloadedStrings
      QuantifiedConstraints
      QuasiQuotes
      PatternSynonyms
      RankNTypes
      RecordWildCards
      ScopedTypeVariables
      StandaloneDeriving
      StrictData
      TemplateHaskell
      TupleSections
      TypeApplications
      TypeFamilies
      TypeOperators
      UndecidableInstances
      ViewPatterns
  ghc-options: -Weverything -Wno-missing-exported-signatures -Wno-missing-import-lists -Wno-missed-specialisations -Wno-all-missed-specialisations -Wno-unsafe -Wno-safe -Wno-missing-local-signatures -Wno-monomorphism-restriction -Wno-implicit-prelude -Wno-partial-fields -Wno-missing-safe-haskell-mode -Wno-prepositive-qualified-module
  include-dirs:
      grammar/camligo/src
      grammar/jsligo/src
  c-sources:
      grammar/camligo/src/parser.c
      grammar/camligo/src/scanner.c
      grammar/jsligo/src/parser.c
      grammar/jsligo/src/scanner.c
  build-depends:
      aeson
    , algebraic-graphs
    , base-noprelude
    , bytestring
    , containers
    , data-default
    , dlist
    , duplo
    , fastsum
    , filepath
    , free
    , ghc-prim
    , interpolate
    , katip
    , lens
    , lsp-types
    , morley-prelude
    , mtl
    , process
    , process-extras
    , regex-tdfa
    , template-haskell
    , temporary
    , text
    , th-compat
    , timestats
    , transformers
    , tree-sitter
    , unliftio
    , unliftio-core
    , unliftio-pool
    , unordered-containers
    , witherable
  default-language: Haskell2010

executable ligo-squirrel
  main-is: Main.hs
  other-modules:
      ASTMap
      Language.LSP.Util
      RIO
      RIO.Diagnostic
      RIO.Document
      RIO.Indexing
      RIO.Registration
      RIO.Types
      Paths_ligo_squirrel
  hs-source-dirs:
      app/ligo-squirrel
  default-extensions:
      AllowAmbiguousTypes
      ApplicativeDo
      BangPatterns
      BlockArguments
      ConstraintKinds
      DataKinds
      DeriveAnyClass
      DeriveFoldable
      DeriveFunctor
      DeriveGeneric
      DeriveTraversable
      DerivingStrategies
      DerivingVia
      DuplicateRecordFields
      FlexibleContexts
      FlexibleInstances
      FunctionalDependencies
      GADTs
      GeneralisedNewtypeDeriving
      ImportQualifiedPost
      LambdaCase
      MagicHash
      MultiParamTypeClasses
      MultiWayIf
      NamedFieldPuns
      OverloadedStrings
      QuantifiedConstraints
      QuasiQuotes
      PatternSynonyms
      RankNTypes
      RecordWildCards
      ScopedTypeVariables
      StandaloneDeriving
      StrictData
      TemplateHaskell
      TupleSections
      TypeApplications
      TypeFamilies
      TypeOperators
      UndecidableInstances
      ViewPatterns
  ghc-options: -Weverything -Wno-missing-exported-signatures -Wno-missing-import-lists -Wno-missed-specialisations -Wno-all-missed-specialisations -Wno-unsafe -Wno-safe -Wno-missing-local-signatures -Wno-monomorphism-restriction -Wno-implicit-prelude -Wno-partial-fields -Wno-missing-safe-haskell-mode -Wno-prepositive-qualified-module -threaded -rtsopts "-with-rtsopts=-N -A64m -AL256m -I10 -Iw60"
  build-depends:
      aeson
    , algebraic-graphs
    , base-noprelude
    , clock
    , co-log-core
    , containers
    , data-default
    , dlist
    , duplo
    , filepath
    , focus
    , katip
    , lens
    , ligo-squirrel
    , list-t
    , lsp
    , morley-prelude
    , mtl
    , prettyprinter
    , stm
    , stm-containers
    , timestats
    , unliftio
    , unliftio-core
    , unliftio-pool
    , unordered-containers
    , witherable
  default-language: Haskell2010

executable ligo-vet
  main-is: Main.hs
  hs-source-dirs:
      app/ligo-vet
  default-extensions:
      AllowAmbiguousTypes
      ApplicativeDo
      BangPatterns
      BlockArguments
      ConstraintKinds
      DataKinds
      DeriveAnyClass
      DeriveFoldable
      DeriveFunctor
      DeriveGeneric
      DeriveTraversable
      DerivingStrategies
      DerivingVia
      DuplicateRecordFields
      FlexibleContexts
      FlexibleInstances
      FunctionalDependencies
      GADTs
      GeneralisedNewtypeDeriving
      ImportQualifiedPost
      LambdaCase
      MagicHash
      MultiParamTypeClasses
      MultiWayIf
      NamedFieldPuns
      OverloadedStrings
      QuantifiedConstraints
      QuasiQuotes
      PatternSynonyms
      RankNTypes
      RecordWildCards
      ScopedTypeVariables
      StandaloneDeriving
      StrictData
      TemplateHaskell
      TupleSections
      TypeApplications
      TypeFamilies
      TypeOperators
      UndecidableInstances
      ViewPatterns
  ghc-options: -Weverything -Wno-missing-exported-signatures -Wno-missing-import-lists -Wno-missed-specialisations -Wno-all-missed-specialisations -Wno-unsafe -Wno-safe -Wno-missing-local-signatures -Wno-monomorphism-restriction -Wno-implicit-prelude -Wno-partial-fields -Wno-missing-safe-haskell-mode -Wno-prepositive-qualified-module -threaded -rtsopts "-with-rtsopts=-N -A64m -AL256m"
  build-depends:
      base-noprelude
    , duplo
    , ligo-squirrel
    , morley-prelude
    , optparse-applicative
    , with-utf8
  default-language: Haskell2010

test-suite integration-test
  type: exitcode-stdio-1.0
  main-is: Main.hs
  other-modules:
      Driver
      Test.Integrational.Capabilities.CodeAction.ExtractTypeAlias
      Test.Integrational.Capabilities.Completion
      Test.Integrational.Capabilities.DocumentLink
      Test.Integrational.Capabilities.DocumentSymbol
      Test.Integrational.Capabilities.Find
      Test.Integrational.Capabilities.Hover
      Test.Integrational.Capabilities.Rename
      Test.Integrational.Capabilities.SignatureHelp
      Test.Integrational.Cli
      Test.Integrational.Diagnostics
      Test.Common.Capabilities.CodeAction.ExtractTypeAlias
      Test.Common.Capabilities.Completion
      Test.Common.Capabilities.DocumentLink
      Test.Common.Capabilities.DocumentSymbol
      Test.Common.Capabilities.Find
      Test.Common.Capabilities.Hover
      Test.Common.Capabilities.Rename
      Test.Common.Capabilities.SignatureHelp
      Test.Common.Capabilities.Util
      Test.Common.Diagnostics
      Test.Common.FixedExpectations
      Test.Common.Tasty
      Test.Common.Util
      Test.Common.Util.Parsers
      Paths_ligo_squirrel
  hs-source-dirs:
      test/integration-test/
      test/test-common/
  default-extensions:
      AllowAmbiguousTypes
      ApplicativeDo
      BangPatterns
      BlockArguments
      ConstraintKinds
      DataKinds
      DeriveAnyClass
      DeriveFoldable
      DeriveFunctor
      DeriveGeneric
      DeriveTraversable
      DerivingStrategies
      DerivingVia
      DuplicateRecordFields
      FlexibleContexts
      FlexibleInstances
      FunctionalDependencies
      GADTs
      GeneralisedNewtypeDeriving
      ImportQualifiedPost
      LambdaCase
      MagicHash
      MultiParamTypeClasses
      MultiWayIf
      NamedFieldPuns
      OverloadedStrings
      QuantifiedConstraints
      QuasiQuotes
      PatternSynonyms
      RankNTypes
      RecordWildCards
      ScopedTypeVariables
      StandaloneDeriving
      StrictData
      TemplateHaskell
      TupleSections
      TypeApplications
      TypeFamilies
      TypeOperators
      UndecidableInstances
      ViewPatterns
  ghc-options: -Weverything -Wno-missing-exported-signatures -Wno-missing-import-lists -Wno-missed-specialisations -Wno-all-missed-specialisations -Wno-unsafe -Wno-safe -Wno-missing-local-signatures -Wno-monomorphism-restriction -Wno-implicit-prelude -Wno-partial-fields -Wno-missing-safe-haskell-mode -Wno-prepositive-qualified-module -Wno-incomplete-uni-patterns -threaded -eventlog -rtsopts "-with-rtsopts=-N -A64m -AL256m"
  build-tool-depends:
      tasty-discover:tasty-discover
  build-depends:
      HUnit
    , algebraic-graphs
    , base-noprelude
    , directory
    , duplo
    , filepath
    , hspec-expectations
    , lens
    , ligo-squirrel
    , lsp-types
    , morley-prelude
    , tasty
    , tasty-hunit
    , template-haskell
    , text
    , unliftio
    , unordered-containers
  default-language: Haskell2010

test-suite ligo-contracts-test
  type: exitcode-stdio-1.0
  main-is: Main.hs
  other-modules:
      Driver
      Test.Parsers
      Test.Common.Capabilities.CodeAction.ExtractTypeAlias
      Test.Common.Capabilities.Completion
      Test.Common.Capabilities.DocumentLink
      Test.Common.Capabilities.DocumentSymbol
      Test.Common.Capabilities.Find
      Test.Common.Capabilities.Hover
      Test.Common.Capabilities.Rename
      Test.Common.Capabilities.SignatureHelp
      Test.Common.Capabilities.Util
      Test.Common.Diagnostics
      Test.Common.FixedExpectations
      Test.Common.Tasty
      Test.Common.Util
      Test.Common.Util.Parsers
      Paths_ligo_squirrel
  hs-source-dirs:
      test/ligo-contracts-test/
      test/test-common/
  default-extensions:
      AllowAmbiguousTypes
      ApplicativeDo
      BangPatterns
      BlockArguments
      ConstraintKinds
      DataKinds
      DeriveAnyClass
      DeriveFoldable
      DeriveFunctor
      DeriveGeneric
      DeriveTraversable
      DerivingStrategies
      DerivingVia
      DuplicateRecordFields
      FlexibleContexts
      FlexibleInstances
      FunctionalDependencies
      GADTs
      GeneralisedNewtypeDeriving
      ImportQualifiedPost
      LambdaCase
      MagicHash
      MultiParamTypeClasses
      MultiWayIf
      NamedFieldPuns
      OverloadedStrings
      QuantifiedConstraints
      QuasiQuotes
      PatternSynonyms
      RankNTypes
      RecordWildCards
      ScopedTypeVariables
      StandaloneDeriving
      StrictData
      TemplateHaskell
      TupleSections
      TypeApplications
      TypeFamilies
      TypeOperators
      UndecidableInstances
      ViewPatterns
  ghc-options: -Weverything -Wno-missing-exported-signatures -Wno-missing-import-lists -Wno-missed-specialisations -Wno-all-missed-specialisations -Wno-unsafe -Wno-safe -Wno-missing-local-signatures -Wno-monomorphism-restriction -Wno-implicit-prelude -Wno-partial-fields -Wno-missing-safe-haskell-mode -Wno-prepositive-qualified-module -Wno-incomplete-uni-patterns -threaded -eventlog -rtsopts "-with-rtsopts=-N -A64m -AL256m"
  build-tool-depends:
      tasty-discover:tasty-discover
  build-depends:
      HUnit
    , algebraic-graphs
    , base-noprelude
    , directory
    , duplo
    , filepath
    , hspec-expectations
    , lens
    , ligo-squirrel
    , lsp-types
    , morley-prelude
    , tasty
    , tasty-hunit
    , template-haskell
    , text
    , unliftio
    , unordered-containers
  default-language: Haskell2010

test-suite lsp-handlers-test
  type: exitcode-stdio-1.0
  main-is: Main.hs
  other-modules:
      Driver
      Test.Capabilities.CodeAction
      Test.Capabilities.Completion
      Test.Capabilities.Definition
      Test.Capabilities.DocumentFormatting
      Test.Capabilities.DocumentLink
      Test.Capabilities.DocumentSymbol
      Test.Capabilities.Folding
      Test.Capabilities.Highlights
      Test.Capabilities.Hover
      Test.Capabilities.PrepareRename
      Test.Capabilities.RangeFormatting
      Test.Capabilities.References
      Test.Capabilities.Rename
      Test.Capabilities.SelectionRange
      Test.Capabilities.SignatureHelp
      Test.Capabilities.TypeDefinition
      Test.DirtyFiles
      Test.DisabledFeatures
      Test.Project.Driver
      Test.Common.LSP
      Test.Common.Capabilities.CodeAction.ExtractTypeAlias
      Test.Common.Capabilities.Completion
      Test.Common.Capabilities.DocumentLink
      Test.Common.Capabilities.DocumentSymbol
      Test.Common.Capabilities.Find
      Test.Common.Capabilities.Hover
      Test.Common.Capabilities.Rename
      Test.Common.Capabilities.SignatureHelp
      Test.Common.Capabilities.Util
      Test.Common.Diagnostics
      Test.Common.FixedExpectations
      Test.Common.Tasty
      Test.Common.Util
      Test.Common.Util.Parsers
      Paths_ligo_squirrel
  hs-source-dirs:
      test/lsp-handlers-test/
      test/lsp-handlers-test-common/
      test/test-common/
  default-extensions:
      AllowAmbiguousTypes
      ApplicativeDo
      BangPatterns
      BlockArguments
      ConstraintKinds
      DataKinds
      DeriveAnyClass
      DeriveFoldable
      DeriveFunctor
      DeriveGeneric
      DeriveTraversable
      DerivingStrategies
      DerivingVia
      DuplicateRecordFields
      FlexibleContexts
      FlexibleInstances
      FunctionalDependencies
      GADTs
      GeneralisedNewtypeDeriving
      ImportQualifiedPost
      LambdaCase
      MagicHash
      MultiParamTypeClasses
      MultiWayIf
      NamedFieldPuns
      OverloadedStrings
      QuantifiedConstraints
      QuasiQuotes
      PatternSynonyms
      RankNTypes
      RecordWildCards
      ScopedTypeVariables
      StandaloneDeriving
      StrictData
      TemplateHaskell
      TupleSections
      TypeApplications
      TypeFamilies
      TypeOperators
      UndecidableInstances
      ViewPatterns
  ghc-options: -Weverything -Wno-missing-exported-signatures -Wno-missing-import-lists -Wno-missed-specialisations -Wno-all-missed-specialisations -Wno-unsafe -Wno-safe -Wno-missing-local-signatures -Wno-monomorphism-restriction -Wno-implicit-prelude -Wno-partial-fields -Wno-missing-safe-haskell-mode -Wno-prepositive-qualified-module -Wno-incomplete-uni-patterns -threaded -eventlog -rtsopts "-with-rtsopts=-N -A64m -AL256m"
  build-tool-depends:
      tasty-discover:tasty-discover
  build-depends:
      HUnit
    , aeson
    , algebraic-graphs
    , base-noprelude
    , data-default
    , directory
    , duplo
    , filepath
    , hspec-expectations
    , interpolate
    , lens
    , ligo-squirrel
    , lsp-test
    , lsp-types
    , morley-prelude
    , tasty
    , tasty-hunit
    , template-haskell
    , text
    , unliftio
    , unordered-containers
  default-language: Haskell2010

test-suite lsp-test
  type: exitcode-stdio-1.0
  main-is: Main.hs
  other-modules:
      Driver
      Test.Capabilities.CodeAction.ExtractTypeAlias
      Test.Capabilities.Completion
      Test.Capabilities.DocumentLink
      Test.Capabilities.DocumentSymbol
      Test.Capabilities.Find
      Test.Capabilities.Hover
      Test.Capabilities.Rename
      Test.Capabilities.SelectionRange
      Test.Capabilities.SignatureHelp
      Test.Diagnostics
      Test.Graph
      Test.Parsers
      Test.Pretty
      Test.Scope.ScopedDecl
      Test.Common.Capabilities.CodeAction.ExtractTypeAlias
      Test.Common.Capabilities.Completion
      Test.Common.Capabilities.DocumentLink
      Test.Common.Capabilities.DocumentSymbol
      Test.Common.Capabilities.Find
      Test.Common.Capabilities.Hover
      Test.Common.Capabilities.Rename
      Test.Common.Capabilities.SignatureHelp
      Test.Common.Capabilities.Util
      Test.Common.Diagnostics
      Test.Common.FixedExpectations
      Test.Common.Tasty
      Test.Common.Util
      Test.Common.Util.Parsers
      Paths_ligo_squirrel
  hs-source-dirs:
      test/lsp-test/
      test/test-common/
  default-extensions:
      AllowAmbiguousTypes
      ApplicativeDo
      BangPatterns
      BlockArguments
      ConstraintKinds
      DataKinds
      DeriveAnyClass
      DeriveFoldable
      DeriveFunctor
      DeriveGeneric
      DeriveTraversable
      DerivingStrategies
      DerivingVia
      DuplicateRecordFields
      FlexibleContexts
      FlexibleInstances
      FunctionalDependencies
      GADTs
      GeneralisedNewtypeDeriving
      ImportQualifiedPost
      LambdaCase
      MagicHash
      MultiParamTypeClasses
      MultiWayIf
      NamedFieldPuns
      OverloadedStrings
      QuantifiedConstraints
      QuasiQuotes
      PatternSynonyms
      RankNTypes
      RecordWildCards
      ScopedTypeVariables
      StandaloneDeriving
      StrictData
      TemplateHaskell
      TupleSections
      TypeApplications
      TypeFamilies
      TypeOperators
      UndecidableInstances
      ViewPatterns
  ghc-options: -Weverything -Wno-missing-exported-signatures -Wno-missing-import-lists -Wno-missed-specialisations -Wno-all-missed-specialisations -Wno-unsafe -Wno-safe -Wno-missing-local-signatures -Wno-monomorphism-restriction -Wno-implicit-prelude -Wno-partial-fields -Wno-missing-safe-haskell-mode -Wno-prepositive-qualified-module -Wno-incomplete-uni-patterns -threaded -eventlog -rtsopts "-with-rtsopts=-N -A64m -AL256m"
  build-tool-depends:
      tasty-discover:tasty-discover
  build-depends:
      HUnit
    , QuickCheck
    , algebraic-graphs
    , base-noprelude
    , directory
    , duplo
    , filepath
    , hspec-expectations
    , lens
    , ligo-squirrel
    , lsp-types
    , morley-prelude
    , tasty
    , tasty-hunit
    , tasty-quickcheck
    , template-haskell
    , text
    , unliftio
    , unordered-containers
  default-language: Haskell2010

benchmark lsp-handlers-bench
  type: exitcode-stdio-1.0
  main-is: Main.hs
  other-modules:
      Bench.Complex
      Bench.Hovers
      Bench.Orphans
      Bench.References
      Bench.Util
      Test.Common.LSP
      Paths_ligo_squirrel
  hs-source-dirs:
      bench/lsp-handlers-bench/
      test/lsp-handlers-test-common
  default-extensions:
      AllowAmbiguousTypes
      ApplicativeDo
      BangPatterns
      BlockArguments
      ConstraintKinds
      DataKinds
      DeriveAnyClass
      DeriveFoldable
      DeriveFunctor
      DeriveGeneric
      DeriveTraversable
      DerivingStrategies
      DerivingVia
      DuplicateRecordFields
      FlexibleContexts
      FlexibleInstances
      FunctionalDependencies
      GADTs
      GeneralisedNewtypeDeriving
      ImportQualifiedPost
      LambdaCase
      MagicHash
      MultiParamTypeClasses
      MultiWayIf
      NamedFieldPuns
      OverloadedStrings
      QuantifiedConstraints
      QuasiQuotes
      PatternSynonyms
      RankNTypes
      RecordWildCards
      ScopedTypeVariables
      StandaloneDeriving
      StrictData
      TemplateHaskell
      TupleSections
      TypeApplications
      TypeFamilies
      TypeOperators
      UndecidableInstances
      ViewPatterns
  ghc-options: -Weverything -Wno-missing-exported-signatures -Wno-missing-import-lists -Wno-missed-specialisations -Wno-all-missed-specialisations -Wno-unsafe -Wno-safe -Wno-missing-local-signatures -Wno-monomorphism-restriction -Wno-implicit-prelude -Wno-partial-fields -Wno-missing-safe-haskell-mode -Wno-prepositive-qualified-module -Wno-incomplete-uni-patterns -threaded -eventlog -rtsopts "-with-rtsopts=-N -A64m -AL256m"
  build-depends:
      aeson
    , base-noprelude
    , criterion
    , data-default
    , directory
    , ligo-squirrel
    , lsp-test
    , lsp-types
    , morley-prelude
    , text
  default-language: Haskell2010
